x = 4;

Xall = [];
Uall = [];

while true
    x0.setValue(x);
    sol.resolve();

    % Obtain the control value at t=0
    u = optival(U(1));
    
    % Bring the physical system one step further
    x = rk4(ode,T/N,x,u);
   
    Xall = [Xall x];
    Uall = [Uall u];
    
    % Do not remember history larger than 50
    if size(Xall,2)>50
       Xall = Xall(2:50);
       Uall = Uall(2:50);
    end
     
    % Perturb if ctrl is pressed
    modifiers = get(gcf,'currentModifier');
    if ismember('control',modifiers)
       x=x+1; 
    end
    
    clf
    title('Press <ctrl> to perturb')
    hold on
    plot(Xall,'b','LineWidth',3);
    stairs(Uall,'r','LineWidth',3);
    
    % Plot the expected future
    plot(size(Xall,2):size(Xall,2)+N,optival(X),'b');
    stairs(size(Xall,2):size(Xall,2)+N-1,optival(U),'r');
    
    grid on
    
    pause(0.01);
end